/* David Leonard, 2002. Public domain. */
/* $Id: proto.h,v 1.1.1.1 2002/01/29 04:48:28 d Exp $ */

struct protostate;
struct proto {
	int	port;			/* Server's listen port number */
	int	statesize;		/* Private state storage size */
	void	(*init)(void *state);
	void	(*decode)(void *state, void *context, int reverse,
			const unsigned char *data, int datalen);
	void	(*final)(void *state, int cremain, int sremain);
};

/* Protocol decoder API */
void	proto_print(void *context, const unsigned char *end,
		const char *fmt, ...);

/* Packet feeder API */
struct protostate *proto_open(int, int);
void proto_feed(struct protostate *, int, const unsigned char *, int);
void proto_close(struct protostate *);
const char *quotestr(const char *, int len);	/* make a string readable */
