/* David Leonard, 2002. Public domain */
/* $Id: proto_raw.c,v 1.1.1.1 2002/01/29 04:48:28 d Exp $ */

#include <stdio.h>
#include "proto.h"

/* Default protocol decoder (simply shows raw ASCII content) */

static void
decode(state, context, reverse, data, datalen)
	void *state;
	void *context;
	int reverse;
	const unsigned char *data;
	int datalen;
{
	const unsigned char *dend = data + datalen;
	char line[16];
	int i;

	while (data < dend) {
		memset(line, '\0', sizeof line);
		for (i = 0; i < 16 && data < dend; i ++) {
			if (*data == '\0')
				line[i] = ' ';
			else if (*data >= ' ' && *data <= '~')
				line[i] = *data;
			else
				line[i] = '.';
			data++;
		}
		proto_print(context, data,
		    "%.4s %.4s %.4s %.4s", line, line + 4, line + 8, line + 12);
	}
}

struct proto proto_raw = {
	-1, 	/* port */
	0,	/* state */
	0,	/* init */
	decode,	/* decode */
	0	/* final */
};
